define-command -override -params 1 latex-surround-add-impl %~
    evaluate-commands -save-regs 'a' -no-hooks %^
        set-register a %arg{1}
        execute-keys -draft '_i\<c-r>a{<esc>a}'
    ^
~
define-command -override -params 1 latex-surround-remove-impl %~
    evaluate-commands -save-regs 'a"' -no-hooks %^
        set-register a %arg{1}
        execute-keys -save-regs '"' -draft '<a-/>\\<c-r>a<ret>d<a-a>{<a-S>d'
    ^
~

define-command -override latex-surround-add %{
    prompt add: %{
        latex-surround-add-impl %val{text}
    }
}

define-command -override latex-surround-remove %{
    prompt remove: %{
        latex-surround-remove-impl %val{text}
    }
}

hook global WinSetOption filetype=latex %{
	set-option window formatcmd "tex-fmt --stdin"
	set-option window autowrap_fmtcmd 'fmt -w %c'
    # set-option window autowrap_format_paragraph true
	# hook -group latex-auto-format window BufWritePre .* %{
 #    	try format
	# }
	hook -once -always window WinSetOption filetype=.* %{
		unset-option window formatcmd
		remove-hooks window latex-auto-format
	}
	declare-filetype-mode latex
    map window latex i ': latex-surround-add-impl emph<ret>' -docstring 'italicize selection'
    map window latex <a-i> ': latex-surround-remove-impl emph<ret>' -docstring 'deitalicize selection'
    map window latex b ': latex-surround-add-impl textbf<ret>' -docstring 'bold selection'
    map window latex <a-b> ': latex-surround-remove-impl textbf<ret>' -docstring 'debold selection'
    map window latex s ': latex-surround-add<ret>' -docstring 'surround add'
    map window latex r ': latex-surround-remove<ret>' -docstring 'surround remove'
}

