# format markdown, ignoring certain patterns!
define-command markdown-fmt %{
    evaluate-commands -draft -save-regs "/lf" %{
        # block level images or abbreviations regex
        set-register / '(?S)(^\h*!\[.*\]\(.*\)$|^\*\[.*\]:.*$)'
        # select, yank, replace with comment
        try %{
            execute-keys -draft '%s<ret>"lyc<lt>!--ignore𝅙ignore--<gt><esc>'
        }
        # pass to formatter
        evaluate-commands -draft %{ format }
        # select the comments, replace with original content
        set-register / '(?S)^\h*<!--ignore𝅙ignore-->'
        try %{
            execute-keys -draft '%s<ret>"lR'
        }
    }
}

hook global WinSetOption filetype=markdown %{
    # explicitly load to avoid race condition
    set-option window comment_line ''
    set-option window comment_block_begin '<!--'
    set-option window comment_block_end '-->'

    require-module markdown
	set-option window formatcmd %{
        if dprint output-resolved-config >/dev/null 2>&1; then
            dprint fmt --stdin md
        else
            dprint fmt --stdin md --config "$HOME/.dprint.jsonc"
        fi
	}
	hook -group markdown-auto-format window BufWritePre .* %{ markdown-fmt }
	map window normal = ': markdown-fmt<ret>'

    # override formatting commands
    define-command -override -hidden markdown-trim-indent %{
        evaluate-commands -no-hooks -draft -itersel %{
            execute-keys x
            # remove trailing white spaces
            # try %{ execute-keys -draft s \h + $ <ret> d }
        }
    }

    define-command -override -hidden markdown-insert-on-new-line %{
        try %{ execute-keys -draft -itersel k x s ^\h*\K((>\h*)+([*+-]\h)?|(>\h*)*[*+-]\h)\h* <ret> y gh j P }
    }

    define-command -override -hidden markdown-indent-on-new-line %{
        evaluate-commands -draft -itersel %{
            # preserve previous line indent
            try %{ execute-keys -draft <semicolon> K <a-&> }
            # remove trailing white spaces
            # try %{ execute-keys -draft k x s \h+$ <ret> d }
        }
    }


	# hook -once -always WinSetOption filetype=.* %{
	# 	unset-option window formatcmd
	# 	remove-hooks window markdown-auto-format
	# }
}
