hook global BufCreate .+[.](mmd|mermaid) %{
    set-option buffer filetype mermaid
}

hook global WinSetOption filetype=mermaid %{
    require-module mermaid

    hook window InsertChar \n -group mermaid-indent mermaid-indent-on-new-line
    hook window ModeChange pop:insert:.* -group mermaid-trim-indent mermaid-trim-indent

    hook -once -always window WinSetOption filetype=.* %{ remove-hooks window mermaid-.+ }
    
    set-option window indentwidth 2
    set-option window comment_line '%%'
}

provide-module mermaid %—
    # TODO: regex highlighting (treesitter is overkill lol)
    define-command -hidden mermaid-indent-on-new-line %~
        # preserve previous line indent
        try %{ execute-keys -draft <semicolon> K <a-&> }
        # remove trailing white spaces
        try %{ execute-keys -draft k x s \h+$ <ret> d }
    ~

    define-command -hidden mermaid-trim-indent %{
        # rm trailing whitespace
        try %{ execute-keys -draft -itersel x s \h+$ <ret> d }
    }
—
